/*
 * lcd_ch.h
 *
 * Created: 3/10/2021 7:05:39 PM
 *  Author: Admin
 */
#ifndef F_CPU
#define F_CPU 16000000UL /* Define CPU frequency here 16MHz */
#endif

#ifndef LCD_CH_H_
#define LCD_CH_H_

#include <avr/io.h>
#include <util/delay.h>
#include <stdbool.h>

// LCD  klasik zapojenie vid. MIPS
//   - http://senzor.robotika.sk/sensorwiki/index.php/LCD_displej_s_radi%C4%8Dom_HD44780

#define LCD_CTRL_DDR DDRD
#define LCD_CTRL_PORT PORTD

#define LCD_DATA_DDR DDRB
#define LCD_DATA_PORT PORTB
#define LCD_DATA_PIN PINB

#define LCD_RS_pin 2
#define LCD_RW_pin 3
#define LCD_EN_pin 4

#define LCD_D4_pin 1
#define LCD_D5_pin 2
#define LCD_D6_pin 3
#define LCD_D7_pin 4

// Oneskorenie 6 SC
#define NOP() asm("nop")
#define LCD_DELAY \
    NOP();        \
    NOP();        \
    NOP();        \
    NOP();        \
    NOP();        \
    NOP();

#define PORT_DATA_WR_H(x)        \
    LCD_DATA_PORT &= 0b11100001; \
    LCD_DATA_PORT |= (x & 0xF0) >> 3
#define PORT_DATA_WR_L(x)        \
    LCD_DATA_PORT &= 0b11100001; \
    LCD_DATA_PORT |= (x & 0x0F) << 1
#define PORT_DATA_RD_H ((LCD_DATA_PIN & ((1 << LCD_D4_pin) | (1 << LCD_D5_pin) | (1 << LCD_D6_pin) | (1 << LCD_D7_pin))) << 3)
#define PORT_DATA_RD_L ((LCD_DATA_PIN & ((1 << LCD_D4_pin) | (1 << LCD_D5_pin) | (1 << LCD_D6_pin) | (1 << LCD_D7_pin))) >> 1)

void lcd_init(void);
void lcd_putc(char ch);
void lcd_puts(char *str);
void lcd_cursor(bool value);
void def_spec_znaky(void);

#endif /* LCD_CH_H_ */